#if !defined( _JMap2PixelObj_h )
#define _JMap2PixelObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"

#include "gps.h"
#include "neattools_mapper.h"



class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JMap2PixelObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      LATITUDE,
      LONGITUDE,
	D_LATITUDE,
	D_LONGITUDE,
	MAP_NAME,
	UL_LATITUDE,
	UL_LONGITUDE,
	LR_LATITUDE,
	LR_LONGITUDE,
	PIXEL_WIDTH,
	PIXEL_HEIGHT
	};

    virtual const char* className() const;
    virtual JObject* clone() const;
    JMap2PixelObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
	void remap( char* longitude, char* latitude );
	void d_remap( double longitude, double latitude );
  private:
	  void dobroadcasts();
	  void updatePixelOutputs();
	  void handleInput( int n, JLinkObj& link, int fieldIndicator );

    // inputs
    JString latitude;
    JString longitude;
	double d_latitude;
	double d_longitude;

    // properties
    JString ul_latitude;
    JString ul_longitude;
    JString lr_latitude;
    JString lr_longitude;
    JString map_name;
    int pixel_width;
    int pixel_height;

    // outputs
    int in_map;
    int pixel_x;
    int pixel_y;

	// private variables
	neattools_mapper pixelMapper;
	int lastRemapType;
	void redoMapping();
};


#endif
